/***************************************************************************
                 lineasalbaranesprov.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
		function calculateField(fN:String):String { return this.ctx.interna_calculateField(fN); }
		function acceptedForm() { return this.ctx.interna_acceptedForm(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); } 
	function desconectar() {
		return this.ctx.oficial_desconectar();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
	function actualizarEstadoPedido(idPedido:Number, curAlbaran:FLSqlCursor):Boolean {
		return this.ctx.oficial_actualizarEstadoPedido(idPedido, curAlbaran);
	}
	function actualizarLineaPedido(idLineaPedido:Number, idPedido:Number, referencia:String, idAlbaran:Number, cantidadLineaAlbaran:Number):Boolean {
		return this.ctx.oficial_actualizarLineaPedido(idLineaPedido, idPedido, referencia, idAlbaran, cantidadLineaAlbaran);
	}
	function obtenerEstadoPedido(idPedido:Number):String {
		return this.ctx.oficial_obtenerEstadoPedido(idPedido);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
    function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx*/
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_actualizarEstadoPedido(idPedido:Number, curAlbaran:FLSqlCursor):Boolean {
		return this.actualizarEstadoPedido(idPedido, curAlbaran);
	}
	function pub_actualizarLineaPedido(idLineaPedido:Number, idPedido:Number, referencia:String, idAlbaran:Number, cantidadLineaAlbaran:Number) {
		return this.actualizarLineaPedido(idLineaPedido, idPedido, referencia, idAlbaran, cantidadLineaAlbaran);
	}
	function pub_obtenerEstadoPedido(idPedido:Number):String {
		return this.obtenerEstadoPedido(idPedido);
	}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este formulario realiza la gestin de las lneas de albaranes a proveedores.
\end */
function interna_init()
{
		var util:FLUtil = new FLUtil();
		var cursor:FLSqlCursor = this.cursor();
		connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
		connect(form, "closed()", this, "iface.desconectar");
		
		if (cursor.modeAccess() == cursor.Insert)
				this.child("fdbDtoPor").setValue(this.iface.calculateField("dtopor"));

		this.child("lblDtoPor").setText(this.iface.calculateField("lbldtopor"));
		
		var serie:String = cursor.cursorRelation().valueBuffer("codserie");
		var siniva:Boolean = util.sqlSelect("series","siniva","codserie = '" + serie + "'");
		if(siniva){
			this.child("fdbCodImpuesto").setDisabled(true);
			this.child("fdbIva").setDisabled(true);
			this.child("fdbRecargo").setDisabled(true);
			cursor.setValueBuffer("codimpuesto","");
			cursor.setValueBuffer("iva",0);
			cursor.setValueBuffer("recargo",0);
		}
}

/** \C
Los campos calculados de este formulario son los mismos que los del formulario de lneas de pedido a proveedor
\end */
function interna_calculateField(fN:String):String
{
		return formRecordlineaspedidosprov.iface.pub_commonCalculateField(fN, this.cursor());
}

function interna_acceptedForm()
{
		var cursor:FLSqlCursor = this.cursor();
		this.iface.actualizarLineaPedido(cursor.valueBuffer("idlineapedido"), cursor.valueBuffer("idpedido") , cursor.valueBuffer("referencia"), cursor.valueBuffer("idalbaran"), cursor.valueBuffer("cantidad"));
		this.iface.actualizarEstadoPedido(cursor.valueBuffer("idpedido"), cursor);
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_desconectar()
{
		disconnect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}

/** \C
Las dependencias entre controles de este formulario son las mismas que las del formulario de lneas de pedido a proveedor
\end */
function oficial_bufferChanged(fN:String)
{
		formRecordlineaspedidosprov.iface.pub_commonBufferChanged(fN, form);
}

/** \C
Obtiene el estado de un pedido
@param	idPedido: Id del pedido a actualizar
@return	True si la actualizacin se realiza correctamente, false en caso contrario
\end */
function oficial_obtenerEstadoPedido(idPedido:Number):String
{	
	var query:FLSqlQuery = new FLSqlQuery();

	query.setTablesList("lineaspedidosprov");
	query.setSelect("cantidad, totalenalbaran");
	query.setFrom("lineaspedidosprov");
	query.setWhere("idpedido = " + idPedido);
	if (!query.exec())
		return false;

	var estado:String = "S";
	var totalServida:Number = 0;
	while (query.next()) {
		var cantidad:Number = parseFloat(query.value(0));
		var cantidadServida:Number = parseFloat(query.value(1));
		totalServida += cantidadServida;
		if (estado == "S")
			if (cantidad > cantidadServida) 
				estado = "Parcial";
	}
	
	if (totalServida == 0)
		estado = "No";
	return estado;
}

/** \C
Marca el pedido como servido o parcialmente servido segn corresponda.
@param	idPedido: Id del pedido a actualizar
@param	curAlbaran: Cursor posicionado en el albarn que modifica el estado del pedido
@return	True si la actualizacin se realiza correctamente, false en caso contrario
\end */
function oficial_actualizarEstadoPedido(idPedido:Number, curAlbaran:FLSqlCursor):Boolean
{
	var estado:String = this.iface.obtenerEstadoPedido(idPedido);
	if (!estado)
		return false;
		
	var curPedido:FLSqlCursor = new FLSqlCursor("pedidosprov");
	curPedido.select("idpedido = " + idPedido);
	if (curPedido.first()) {
		if (estado == curPedido.valueBuffer("servido"))
			return true;
		curPedido.setUnLock("editable", true);
	}
	
	curPedido.select("idpedido = " + idPedido);
	curPedido.setModeAccess(curPedido.Edit);
	if (curPedido.first()) {
		curPedido.setValueBuffer("servido", estado);
		if (estado == "S")
			curPedido.setValueBuffer("editable", false);
		if (!curPedido.commitBuffer())
			return false;
	}
	return true;
}

/** \C
Actualiza el campo total en albarn de la lnea de pedido correspondiente (si existe).
@param	idLineaPedido: Id de la lnea a actualizar
@param	idPedido: Id del pedido a actualizar
@param	referencia del artculo contenido en la lnea
@param	idAlbaran: Id del albarn en el que se sirve el pedido
@param	cantidadLineaAlbaran: Cantidad total de artculos de la referencia actual en el albarn
@return	True si la actualizacin se realiza correctamente, false en caso contrario
\end */
function oficial_actualizarLineaPedido(idLineaPedido:Number, idPedido:Number, referencia:String, idAlbaran:Number, cantidadLineaAlbaran:Number):Boolean
{
	if (idLineaPedido == 0)
		return true;
	
	var cantidadServida:Number;
	var curLineaPedido:FLSqlCursor = new FLSqlCursor("lineaspedidosprov");
	curLineaPedido.select("idlinea = " + idLineaPedido);
	curLineaPedido.setModeAccess(curLineaPedido.Edit);
	if (!curLineaPedido.first())
		return true;

	var cantidadPedido:Number = parseFloat(curLineaPedido.valueBuffer("cantidad"));
	var query:FLSqlQuery = new FLSqlQuery();
	query.setTablesList("lineasalbaranesprov");
	query.setSelect("SUM(cantidad)");
	query.setFrom("lineasalbaranesprov");
	query.setWhere("idlineapedido = " + idLineaPedido + " AND idalbaran <> " + idAlbaran);
	if (!query.exec())
		return false;
	if (query.next())
		cantidadServida = parseFloat(query.value(0)) + parseFloat(cantidadLineaAlbaran);
	if (cantidadServida > cantidadPedido)
		cantidadServida = cantidadPedido;
	
	curLineaPedido.setValueBuffer("totalenalbaran", cantidadServida);
	if (!curLineaPedido.commitBuffer())
		return false;
		
	return true;
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
