/***************************************************************************
                 lineaspedidosprov.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
	function calculateField(fN:String):String { return this.ctx.interna_calculateField(fN); }
	function validateForm():Boolean { return this.ctx.interna_validateForm(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); } 
	function desconectar() {
		return this.ctx.oficial_desconectar();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
	function commonBufferChanged(fN:String, miForm:Object) {
		return this.ctx.oficial_commonBufferChanged(fN, miForm);
	}
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.ctx.oficial_commonCalculateField(fN, cursor);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
    function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
		function pub_commonCalculateField(fN:String, cursor:FLSqlCursor):String {
				return this.commonCalculateField(fN, cursor);
		}
		function pub_commonBufferChanged(fN:String, miForm:Object) {
				return this.commonBufferChanged(fN, miForm);
		}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este formulario realiza la gestin de las lneas de pedidos a proveedores.
\end */
function interna_init()
{
		var util:FLUtil = new FLUtil();
		var cursor:FLSqlCursor = this.cursor();
		connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
		connect(form, "closed()", this, "iface.desconectar");
		
		if (cursor.modeAccess() == cursor.Insert)
				this.child("fdbDtoPor").setValue(this.iface.calculateField("dtopor"));

		this.child("lblDtoPor").setText(this.iface.calculateField("lbldtopor"));
		
		var serie:String = cursor.cursorRelation().valueBuffer("codserie");
		var siniva:Boolean = util.sqlSelect("series","siniva","codserie = '" + serie + "'");
		if(siniva){
			this.child("fdbCodImpuesto").setDisabled(true);
			this.child("fdbIva").setDisabled(true);
			this.child("fdbRecargo").setDisabled(true);
			cursor.setValueBuffer("codimpuesto","");
			cursor.setValueBuffer("iva",0);
			cursor.setValueBuffer("recargo",0);
		}
}

function interna_calculateField(fN:String):String
{
		return this.iface.commonCalculateField(fN, this.cursor());
		/** \C
		El --pvpunitario-- ser el correspondiente al coste por proveedor y moneda correspondiente a la --referencia-- seleccionada
		\end */
		/** \C
		El --codimpuesto-- ser el correspondiente a la --referencia-- seleccionada
		\end */
		/** \C
		El --iva-- ser el correspondiente al --codimpuesto-- en la tabla de impuestos
		\end */
		/** \C
		El --pvptotal-- ser el --pvpsindto-- menos el --dtopor-- y menos el --dtolineal--
		\end */
		/** \C
		El --dtopor-- ser el descuento asociado al proveedor
		\end */
		/** \C
		El --recargo-- ser el correspondiente al --codimpuesto-- en la tabla de impuestos en el caso de la empresa tenga activado el campo Aplicar recargo de equivalencia en su correspondiente formulario.
		\end */
		/** \C
		El --pvpsindto-- ser el producto del campo --cantidad-- por el campo --pvpunitario--
		\end */
}

function interna_validateForm():Boolean
{
		/** \C
		La cantidad de artculos especificada ser mayor o igual que la del --totalenalbaran--
		\end */
		if (parseFloat(this.cursor().valueBuffer("cantidad")) < parseFloat(this.cursor().valueBuffer("totalenalbaran")))
				return false;
		else
				return true;
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_desconectar()
{
		disconnect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}

function oficial_bufferChanged(fN:String)
{
		this.iface.commonBufferChanged(fN, form);
		/** \C
		Al cambiar la --referencia-- se mostrarn los valores asociados de --pvpvunitario-- y --codimpuesto--
		\end */
		/** \C
		Al cambiar el --codimpuesto-- se mostrarn los valores asociados de --iva-- y --recargo--
		\end */
		/** \C
		Al cambiar la --cantidad-- o el --pvpunitario-- se mostrar el valor asociado de --pvptotal--
		\end */
		/** \C
		Al cambiar el --pvpsindto--, el --dtopor-- o el --dtolineal-- se mostrar el valor asociado de --pvptotal--
		\end */
}

function oficial_commonBufferChanged(fN:String, miForm:Object)
{
		switch (fN) {
		case "referencia":{
						var util:FLUtil = new FLUtil();
						miForm.child("fdbPvpUnitario").setValue(this.iface.commonCalculateField("pvpunitario", miForm.cursor()));
						var serie:String = miForm.cursor().cursorRelation().valueBuffer("codserie");
						var sinIva:Boolean = util.sqlSelect("series","siniva","codserie = '" + serie + "'");
						if(sinIva == false)
							miForm.child("fdbCodImpuesto").setValue(this.iface.commonCalculateField("codimpuesto", miForm.cursor()));
						break;
				}
		case "codimpuesto":{
						miForm.child("fdbIva").setValue(this.iface.commonCalculateField("iva", miForm.cursor()));
						miForm.child("fdbRecargo").setValue(this.iface.commonCalculateField("recargo", miForm.cursor()));
						break;
				}
		case "cantidad":
		case "pvpunitario":{
						miForm.child("fdbPvpSinDto").setValue(this.iface.commonCalculateField("pvpsindto", miForm.cursor()));
						break;
				}
		case "pvpsindto":
		case "dtopor":{
						miForm.child("lblDtoPor").setText(this.iface.commonCalculateField("lbldtopor", miForm.cursor()));
				}
		case "dtolineal":{
						miForm.child("fdbPvpTotal").setValue(this.iface.commonCalculateField("pvptotal", miForm.cursor()));
						break;
				}
		}
}

function oficial_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
		var util:FLUtil = new FLUtil();
		var wherePadre:String;
		var tablaPadre:String;
		var tabla:String = cursor.table();
		if (tabla == "lineaspedidosprov") {
				wherePadre = "idpedido = "+ cursor.valueBuffer("idpedido");
				tablaPadre = "pedidosprov";
		}
		if (tabla == "lineasalbaranesprov") {
				wherePadre = "idalbaran = "+ cursor.valueBuffer("idalbaran");
				tablaPadre = "albaranesprov";
		}
		if (tabla == "lineasfacturasprov") {
				wherePadre = "idfactura = "+ cursor.valueBuffer("idfactura");
				tablaPadre = "facturasprov";
		}
		
		var valor:String;
		switch (fN) {
		case "pvpsindto":{
						valor = parseFloat(cursor.valueBuffer("pvpunitario")) * parseFloat(cursor.valueBuffer("cantidad"));
						valor = util.roundFieldValue(valor, "lineaspedidosprov", "pvptotal");
						break;
				}
		case "codimpuesto":{
						valor = util.sqlSelect("articulos", "codimpuesto", "referencia = '" + cursor.valueBuffer("referencia") + "'");
						break;
				}
		case "iva":{
						valor = util.sqlSelect("impuestos", "iva", "codimpuesto = '" + cursor.valueBuffer("codimpuesto") + "'");
						break;
				}
		case "lbldtopor":{
						valor = (cursor.valueBuffer("pvpsindto") * cursor.valueBuffer("dtopor")) / 100;
						valor = util.roundFieldValue(valor, "lineaspedidosprov", "pvpsindto");
						break;
				}
		case "pvptotal":{
						var dtoPor:Number = (cursor.valueBuffer("pvpsindto") * cursor.valueBuffer("dtopor")) / 100;
						dtoPor = util.roundFieldValue(dtoPor, "lineaspedidosprov", "pvpsindto");
						valor = cursor.valueBuffer("pvpsindto") - parseFloat(dtoPor) - cursor.valueBuffer("dtolineal");
						break;
				}
		case "dtopor":{
						var codProveedor:String = util.sqlSelect(tablaPadre, "codproveedor", wherePadre);
						valor = flfactppal.iface.pub_valorQuery("descuentosproveedores,descuentos", "SUM(d.dto)", "descuentosproveedores dc INNER JOIN descuentos d ON dc.coddescuento = d.coddescuento", "dc.codproveedor = '" + codProveedor + "'");
						break;
				}
		case "pvpunitario":{
						var codProveedor:String = util.sqlSelect(tablaPadre, "codproveedor", wherePadre);
						var codDivisa:String = util.sqlSelect(tablaPadre, "coddivisa", wherePadre);
						valor = util.sqlSelect("articulosprov", "coste", "referencia = '" + cursor.valueBuffer("referencia") + "' AND codproveedor = '" + codProveedor + "' AND coddivisa = '" + codDivisa + "'");
						break;
				}
		case "recargo":{
						var aplicarRecEq:Boolean = flfactppal.iface.pub_valorDefectoEmpresa("recequivalencia");
						if (aplicarRecEq == true) {
								valor = util.sqlSelect("impuestos", "recargo", "codimpuesto = '" + cursor.valueBuffer("codimpuesto") + "'");
						}
						break;
				}
		}
		return valor;
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
