/***************************************************************************
                 masterfacturascli.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
	var ctx:Object;
	function interna( context ) { this.ctx = context; }
	function init() { this.ctx.interna_init(); }
	function recordDelBeforefacturascli() {this.ctx.interna_recordDelBeforefacturascli(); }
	function calculateField(fN:String):String {this.ctx.interna_calculateField(fN); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	var pbnAFactura:Object;
	var tbnImprimir:Object;
	var tdbRecords:FLTableDB;
	
    function oficial( context ) { interna( context ); } 
	function imprimir(codFactura:String) {
		return this.ctx.oficial_imprimir(codFactura);
	}
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.ctx.oficial_commonCalculateField(fN, cursor);
	}
	function liberarAlbaranes(idFactura:Number) {
		return this.ctx.oficial_liberarAlbaranes(idFactura);
	}
	function liberarAlbaran(idAlbaran:Number) {
		return this.ctx.oficial_liberarAlbaran(idAlbaran);
	}
	function asociarAFactura() {
		return this.ctx.oficial_asociarAFactura();
	}
	function whereAgrupacion(curAgrupar:FLSqlCursor):String {
		return this.ctx.oficial_whereAgrupacion(curAgrupar);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
    function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_whereAgrupacion(curAgrupar:FLSqlCursor):String {
		return this.whereAgrupacion(curAgrupar);
	}
	function pub_commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.commonCalculateField(fN, cursor);
	}
	function pub_imprimir(codFactura:String):String {
		return this.imprimir(codFactura);
	}
}
const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este es el formulario maestro de facturas a cliente.
\end */
function interna_init()
{
	this.iface.pbnAFactura = this.child("pbnAsociarAFactura");
	this.iface.tbnImprimir = this.child("toolButtonPrint");
	this.iface.tdbRecords= this.child("tableDBRecords");

	connect(this.iface.tbnImprimir, "clicked()", this, "iface.imprimir");
	connect(this.iface.pbnAFactura, "clicked()", this, "iface.asociarAFactura()");

	var codEjercicio = flfactppal.iface.pub_ejercicioActual();
	if (codEjercicio)
		this.cursor().setMainFilter("codejercicio='" + codEjercicio + "'");
}

/** \C
Al borrar una factura, su cdigo ser agregado a la tabla de huecos para que pueda ser reutilizado en futuras facturas
\end */
function interna_recordDelBeforefacturascli()
{
	var cursor:FLSqlCursor = this.cursor();
	this.iface.liberarAlbaranes(cursor.valueBuffer("idfactura"));
}

function interna_calculateField(fN:String):String
{
	return this.iface.commonCalculateField(fN, this.cursor());
	/** \C
	El --cdigo-- se construye como la concatenacin de --codserie--, --codejercicio-- y --numero--
	\end */
	/** \C
	El --total-- es el --neto-- menos el --totalirpf-- ms el --totaliva-- ms el --totalrecargo-- ms el --recfinanciero--
	\end */
	/** \C
	El --totaleuros-- es el producto del --total-- por la --tasaconv--
	\end */
	/** \C
	El --neto-- es la suma del pvp total de las lneas de factura
	\end */
	/** \C
	El --totaliva-- es la suma del iva correspondiente a las lneas de factura
	\end */
	/** \C
	El --totarecargo-- es la suma del recargo correspondiente a las lneas de factura
	\end */
	/** \C
	El --coddir-- corresponde a la direccin del cliente marcada como direccin de facturacin
	\end */
	/** \C
	El --irpf-- es el asociado al --codserie-- del albarn
	\end */
	/** \C
	El --totalirpf-- es el producto del --irpf-- por el --neto--
	\end */
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \C
Al pulsar el botn imprimir se lanzar el informe correspondiente a la factura seleccionada (en caso de que el mdulo de informes est cargado)
\end */
function oficial_imprimir(codFactura:String)
{
	if (sys.isLoadedModule("flfactinfo")) {
		
		var util:FLUtil = new FLUtil;
		var codigo:String;
		if (codFactura) {
			codigo = codFactura;
		} else {
			if (!this.cursor().isValid())
				return;
			codigo = this.cursor().valueBuffer("codigo");
		}
		
		var numCopias:Number = util.sqlSelect("facturascli f INNER JOIN clientes c ON c.codcliente = f.codcliente", "c.copiasfactura", "f.codigo = '" + codigo + "'", "facturascli,clientes");
		if (!numCopias)
			numCopias = 1;
			
		var curImprimir:FLSqlCursor = new FLSqlCursor("i_facturascli");
		curImprimir.setModeAccess(curImprimir.Insert);
		curImprimir.refreshBuffer();
		curImprimir.setValueBuffer("descripcion", "temp");
		curImprimir.setValueBuffer("d_facturascli_codigo", codigo);
		curImprimir.setValueBuffer("h_facturascli_codigo", codigo);
		flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_facturascli", "", "", false, false, "", "i_facturascli", numCopias);
	} else
		flfactppal.iface.pub_msgNoDisponible("Informes");
}

function oficial_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
	var util:FLUtil = new FLUtil();
	var valor:String;

	if (fN == "codigo")
		valor = flfacturac.iface.pub_construirCodigo(cursor.valueBuffer("codserie"), cursor.valueBuffer("codejercicio"), cursor.valueBuffer("numero"));

	switch (fN) {
	case "total":{
			var neto:Number = parseFloat(cursor.valueBuffer("neto"));
			var totalIrpf:Number = parseFloat(cursor.valueBuffer("totalirpf"));
			var totalIva:Number = parseFloat(cursor.valueBuffer("totaliva"));
			var totalRecargo:Number = parseFloat(cursor.valueBuffer("totalrecargo"));
			var recFinanciero:Number = (parseFloat(cursor.valueBuffer("recfinanciero")) * neto) / 100;
			recFinanciero = parseFloat(util.roundFieldValue(recFinanciero, "facturascli", "total"));
			valor = neto - totalIrpf + totalIva + totalRecargo + recFinanciero;
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "total"));
			break;
		}
	case "lblComision":{
			valor = (parseFloat(cursor.valueBuffer("porcomision")) * (parseFloat(cursor.valueBuffer("neto")))) / 100;
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "total"));
			break;
		}
	case "lblRecFinanciero":{
			valor = (parseFloat(cursor.valueBuffer("recfinanciero")) * (parseFloat(cursor.valueBuffer("neto")))) / 100;
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "total"));
			break;
		}
	case "totaleuros":{
			var total:Number = parseFloat(cursor.valueBuffer("total"));
			var tasaConv:Number = parseFloat(cursor.valueBuffer("tasaconv"));
			valor = total * tasaConv;
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "totaleuros"));
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "totaleuros"));
			break;
		}
	case "neto":{
			valor = util.sqlSelect("lineasivafactcli", "SUM(neto)", "idfactura = " + cursor.valueBuffer("idfactura"));
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "neto"));
			break;
		}
	case "totaliva":{
			var codCli:String = cursor.valueBuffer("codcliente");
			var regIva:String = util.sqlSelect("clientes","regimeniva","codcliente = '" + codCli + "'");
			if(regIva == "U.E." || regIva == "Exento"){
				valor = 0;
				break;
			}
			valor = util.sqlSelect("lineasivafactcli", "SUM(totaliva)", "idfactura = " + cursor.valueBuffer("idfactura"));
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "totaliva"));
			break;
		}
	case "totalrecargo":{
			var codCli:String = cursor.valueBuffer("codcliente");
			var regIva:String = util.sqlSelect("clientes","regimeniva","codcliente = '" + codCli + "'");
			if(regIva == "U.E." || regIva == "Exento"){
				valor = 0;
				break;
			}
			valor = util.sqlSelect("lineasivafactcli", "SUM(totalrecargo)", "idfactura = " + cursor.valueBuffer("idfactura"));
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "totalrecargo"));
			break;
		}
	case "coddir": {
			valor = util.sqlSelect("dirclientes", "id", "codcliente = '" + cursor.valueBuffer("codcliente") +  "' AND domfacturacion = 'true'");
			break;
		}
	case "irpf": {
			valor = util.sqlSelect("series", "irpf", "codserie = '" + cursor.valueBuffer("codserie") + "'");
			break;
		}
	case "totalirpf": {
			valor = (parseFloat(cursor.valueBuffer("irpf")) * (parseFloat(cursor.valueBuffer("neto")))) / 100;
			valor = parseFloat(util.roundFieldValue(valor, "facturascli", "totalirpf"));
			break;
		}
	}
	return valor;
}

/** \D
Llama a la funcin liberarAlbaran para todos los albaranes agrupados en una factura
@param idFactura: Identificador de la factura
\end */
function oficial_liberarAlbaranes(idFactura:Number)
{
	var curAlbaranes:FLSqlCursor = new FLSqlCursor("albaranescli");
	curAlbaranes.select("idfactura = " + idFactura);
	while (curAlbaranes.next())
		this.iface.liberarAlbaran(curAlbaranes.valueBuffer("idalbaran"));
}

/** \D
Desbloquea un albarn que estaba asociado a una factura
@param idAlbaran: Identificador del albarn
\end */
function oficial_liberarAlbaran(idAlbaran:Number)
{
	var curAlbaran:FLSqlCursor = new FLSqlCursor("albaranescli");
	with(curAlbaran) {
		select("idalbaran = " + idAlbaran);
		first();
		setUnLock("ptefactura", true);
		setModeAccess(Edit);
		refreshBuffer();
		setValueBuffer("idfactura", "0");
		commitBuffer();
	}
}

/** \C
Al pulsar el botn de asociar a factura se abre la ventana de agrupar albaranes de cliente
\end */
function oficial_asociarAFactura()
{
	var util:FLUtil = new FLUtil;
	var f:Object = new FLFormSearchDB("agruparalbaranescli");
	var cursor:FLSqlCursor = f.cursor();
	var where:String;
	var codCliente:String;

	cursor.setActivatedCheckIntegrity(false);
	cursor.select();
	if (!cursor.first())
		cursor.setModeAccess(cursor.Insert);
	else
		cursor.setModeAccess(cursor.Edit);

	f.setMainWidget();
	cursor.refreshBuffer();
	var acpt:String = f.exec("codejercicio");
	if (acpt) {
		cursor.commitBuffer();
		var curAgruparAlbaranes:FLSqlCursor = new FLSqlCursor("agruparalbaranescli");
		curAgruparAlbaranes.select();
		if (curAgruparAlbaranes.first()) {
			where = this.iface.whereAgrupacion(curAgruparAlbaranes);
			var excepciones:String = curAgruparAlbaranes.valueBuffer("excepciones");
			if (!excepciones.isEmpty())
				where += " AND idalbaran NOT IN (" + excepciones + ")";

			var qryAgruparAlbaranes:FLSqlCursor = new FLSqlQuery;
			qryAgruparAlbaranes.setTablesList("albaranescli");
			qryAgruparAlbaranes.setSelect("codcliente");
			qryAgruparAlbaranes.setFrom("albaranescli");
			qryAgruparAlbaranes.setWhere(where + " GROUP BY codcliente");

			if (!qryAgruparAlbaranes.exec())
				return;

			var totalClientes:Number = qryAgruparAlbaranes.size();
			util.createProgressDialog(util.translate("scripts", "Generando facturas"), totalClientes);
			util.setProgress(1);
			var j:Number = 0;
			
			var curAlbaran:FLSqlCursor = new FLSqlCursor("albaranescli");
			var whereFactura:String;
			while (qryAgruparAlbaranes.next()) {
				codCliente = qryAgruparAlbaranes.value(0);
				whereFactura = where + " AND codcliente = '" + codCliente + "'";
				curAlbaran.transaction(false);
				curAlbaran.select(whereFactura);
				if (!curAlbaran.first()) {
					curAlbaran.rollback();
					util.destroyProgressDialog();
					return;
				}
				curAlbaran.setValueBuffer("fecha", curAgruparAlbaranes.valueBuffer("fecha"));
				if (formalbaranescli.iface.pub_generarFactura(whereFactura, curAlbaran)) {
					curAlbaran.commit();
				} else {
					MessageBox.warning(util.translate("scripts", "Fall la insercin de la factura correspondiente al cliente: ") + codCliente, MessageBox.Ok, MessageBox.NoButton);
					curAlbaran.rollback();
					util.destroyProgressDialog();
					return;
				}
				util.setProgress(++j);
			}
			util.setProgress(totalClientes);
			util.destroyProgressDialog();
		}

		f.close();
		this.iface.tdbRecords.refresh();
	}
}

/** \D
Construye la sentencia WHERE de la consulta que buscar los albaranes a agrupar
@param curAgrupar: Cursor de la tabla agruparalbaranescli que contiene los valores de los criterios de bsqueda
@return Sentencia where
\end */
function oficial_whereAgrupacion(curAgrupar:FLSqlCursor):String
{
	var codCliente:String = curAgrupar.valueBuffer("codcliente");
	var nombreCliente:String = curAgrupar.valueBuffer("nombrecliente");
	var cifNif:String = curAgrupar.valueBuffer("cifnif");
	var codAlmacen:String = curAgrupar.valueBuffer("codalmacen");
	var codPago:String = curAgrupar.valueBuffer("codpago");
	var codDivisa:String = curAgrupar.valueBuffer("coddivisa");
	var codSerie:String = curAgrupar.valueBuffer("codserie");
	var codEjercicio:String = curAgrupar.valueBuffer("codejercicio");
	var fechaDesde:String = curAgrupar.valueBuffer("fechadesde");
	var fechaHasta:String = curAgrupar.valueBuffer("fechahasta");
	var where:String = "ptefactura = 'true'";
	if (codCliente && !codCliente.isEmpty())
		where += " AND codcliente = '" + codCliente + "'";
	if (cifNif && !cifNif.isEmpty())
		where += " AND cifnif = '" + cifNif + "'";
	if (codAlmacen && !codAlmacen.isEmpty())
		where = where + " AND codalmacen = '" + codAlmacen + "'";
	where = where + " AND fecha >= '" + fechaDesde + "'";
	where = where + " AND fecha <= '" + fechaHasta + "'";
	if (codPago && !codPago.isEmpty())
		where = where + " AND codpago = '" + codPago + "'";
	if (codDivisa && !codDivisa.isEmpty())
		where = where + " AND coddivisa = '" + codDivisa + "'";
	if (codSerie && !codSerie.isEmpty())
		where = where + " AND codserie = '" + codSerie + "'";
	if (codEjercicio && !codEjercicio.isEmpty())
		where = where + " AND codejercicio = '" + codEjercicio + "'";
	return where;
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
