/***************************************************************************
                 masterintervalos.qs  -  description
                             -------------------
    begin                : vie ene 27 2006
    copyright            : (C) 2006 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); } 
	function rellenarIntervalos() {
		return this.ctx.oficial_rellenarIntervalos();
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
    function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C Si los datos de intervalos no estn definidos, se insertan
\end */
function interna_init()
{
	var cursor:FLSqlCursor = this.cursor();
	if (cursor.size() <= 0) {
		this.iface.rellenarIntervalos();
		this.child("tableDBRecords").refresh();
	}
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \D Rellena la tabla con los posibles intervalos de fechas
*/
function oficial_rellenarIntervalos()
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = new FLSqlCursor("intervalos");
	var intervalos:Array =
		[["000001", util.translate("scripts", "Hoy"), util.translate("scripts", "Muestra todos los informes con fecha de hoy")],
		["000002", util.translate("scripts", "Ayer"), util.translate("scripts", "Muestra todos los informes con fecha de ayer")],
		["000003", util.translate("scripts", "Esta semana"), util.translate("scripts", "Muestra todos los informes de esta semana")],
		["000004", util.translate("scripts", "Semana pasada"), util.translate("scripts", "Muestra todos los informes de la semana pasada")],
		["000005", util.translate("scripts", "Este mes"), util.translate("scripts", "Muestra todos los informes de este mes")],
		["000006", util.translate("scripts", "Mes pasado"), util.translate("scripts", "Muestra todos los informes del mes pasado")],
		["000007", util.translate("scripts", "Este ao"), util.translate("scripts", "Muestra todos los informes de este ao")],
		["000008", util.translate("scripts", "Ao pasado"), util.translate("scripts", "Muestra todos los informes del ao pasado")],
		["000009", util.translate("scripts", "Siempre"), util.translate("scripts", "Muestra todos los informes existentes")],
		["000010", util.translate("scripts", "Hasta hoy"), util.translate("scripts", "Muestra todos los informes hasta la fecha de hoy")]];
	for (var i:Number = 0; i < intervalos.length; i++) {
		with(cursor) {
			setModeAccess(cursor.Insert);
			refreshBuffer();
			setValueBuffer("codigo", intervalos[i][0]);
			setValueBuffer("intervalo", intervalos[i][1]);
			setValueBuffer("descripcion", intervalos[i][2]);
			commitBuffer();
		}
	}
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
